package wheelviewandroidwrapper;

import main.java.com.lantouzi.wheelview.WheelView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.graphics.Color;
import android.graphics.Typeface;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.support.annotation.NonNull;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import java.util.ArrayList;
import java.util.List;


@Events(values={"value_changed()"})
@Author("Github: kyleduo, Wrapper: Johan Schoeman")
@Version(1.00f)
@ShortName("WheelViewAndroid")
@DependsOn(values={"android-support-v4"})
public class wheelViewAndroidWrapper extends ViewWrapper<WheelView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private WheelView cv;

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new WheelView(ba.context, null);
                this.setObject(cv);
//                addListener1();
//                addListener2();
 	}




//    @Hide
//    public void addListener1(){
//        cv.setCallback(new NiceSpinner.Callback() {
////            @Override
//            public void item_clicked() {

//              if (ba.subExists(eventName + "_item_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_item_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void bottom_clicked() {
//
//              if (ba.subExists(eventName + "_bottom_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_bottom_clicked", true, new Object[0]);
//              }
//            }

//        });
//    }


//      @Hide
//      public void addListener2(){
//        cv.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//              if (ba.subExists(eventName + "_button_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
//              }
//            }
//        });
//      }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}



        public void ShowWheel() {
//		final List<String> items = new ArrayList<String>();
//		for (int i = 1; i <= 101; i++) {
//			items.add(String.valueOf(i));
//		}

//		cv.setItems(items);
//		cv.selectIndex(50);
//		cv.setAdditionCenterMark("m");

		cv.setOnWheelItemSelectedListener(new WheelView.OnWheelItemSelectedListener() {
			@Override
			public void onWheelItemSelected(int position) {
//				BA.Log("Selected item = " + cv.getSelectedPosition());
                                if (ba.subExists(eventName + "_value_changed")) {
                                  ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[0]);
                                }
			}
		});
       }





	public void Fling(int velocityX, int velocityY) {
		cv.fling(velocityX, velocityY);
		cv.invalidate();
	}

	public void setAdditionCenterMark(String additionCenterMark) {
		cv.setAdditionCenterMark(additionCenterMark);
		cv.invalidate();
	}

	public void setSelectedIndex(int index) {
		cv.selectIndex(index);
		cv.invalidate();
	}

	public void smoothSelectIndex(int index) {
		cv.smoothSelectIndex(index);
		cv.invalidate();
	}

	public List<String> getItems() {
		return cv.getItems();
	}

	public void setItems(List<String> items) {
		cv.setItems(items);
		cv.invalidate();
	}

	public int getSelectedPosition() {
		return cv.getSelectedPosition();
	}

        public void setArrowColor(int ac){
            cv.setArrowColor(ac);
            cv.invalidate();
        }

        public void setOtherNumbersColor(int onc){
            cv.setOtherNumbersColor(onc);
            cv.invalidate();
        }

        public void setOtherTicksColor(int otc){
            cv.setOtherTicksColor(otc);
            cv.invalidate();
        }







}
